<template>
    <div class="cities_input input_with_label" @click="is_target=true">
        <div class="arrow wrap" @click="toggleDropdown">
            <div class="arrow target" :class="{opened: show_list}"></div>
        </div>

		<input type="text"
			   v-bind:value="value"
			   @input="$emit('input', $event.target.value);show_list=true;$emit('refresh')"
               @focus="handleValueFocus"
               @blur="handleValueBlur"
               :class="value_class"
			   :placeholder="placeholder"
			   :disabled="disabled"
        >
		<div class="lbl" :class="value ? 'not_empty' : 'empty'">{{placeholder}}</div>
        <!--
            <label>{{placeholder}}</label>
            required="required"
        -->

<!--        <div v-if="value.length">-->
        <div class="list-box-holder">
            <div class="drop_list" v-if="show_list && searchResults.length" v-click-outside="clickOutsideConfig">
                <div
                    class="item"
                    v-for="city in searchResults"
                    @click="selectCity($event, city)"
                >
                    {{ city.name_ua + ' ('+city.region.name_ua+' обл.)'}}
                </div>
                    <!-- v-on:click="$emit('input', $event.target.innerText)" -->
            </div>
            <div class="drop_list" v-if='show_list && !searchResults.length'>
                <div class="item not_found">
                    {{$t('message.nothing_was_found')}}
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    import vClickOutside from 'v-click-outside';

    // import { debounce } from 'lodash';
    export default {
        name: "CitiesInput",
        props: ['value', 'placeholder', 'cities', 'disabled'],
        directives: {
            clickOutside: vClickOutside.directive
        },
        data() {
            return {
                selected: '',
                searchResultsVisible: false,
                show_list: false,
                is_target: false,
                value_class: '',
                // cities: [],

                clickOutsideConfig: {
                    handler: this.toggleDropdown,
                    middleware: this.clickOutsideMiddleware,
                    events: ['dblclick', 'click'],
                    isActive: true
                }
            };
        },
        computed: {
            searchResults() {
                return this.cities.filter(city => {
                    return city.name_ua.toLowerCase().includes(this.value.toLowerCase())
                });
            },
            clicked() {
                return this.$store.getters.clicked;
            }
        },
        methods: {
            handleValueFocus () {
                this.value_class = 'hover';
            },
            handleValueBlur () {
                this.value_class = '';
            },
            selectCity(e, city){
                this.$emit("set-city", city);
                this.show_list = false;
                this.$emit("input", e.target.innerText);
            },
            toggleDropdown(){
                this.show_list =! this.show_list;
                this.$emit('input', '');
                this.$emit('refresh');
            },
            clickOutsideMiddleware (event) {
                return event.target.className !== 'arrow';
            }
        },
        created: function () {
            // this.$parent.$on('click', alert(1))
            // this.cities = this.$store.state.cities;
            // console.log(this.cities)
            // let cities = JSON.parse("[{\"name\":\"Івано-Франківськ\",\"value\":\"Івано-Франківськ\"},{\"name\":\"Ірпінь\",\"value\":\"Ірпінь\"},{\"name\":\"Баришівка\",\"value\":\"Баришівка\"},{\"name\":\"Бахмач\",\"value\":\"Бахмач\"},{\"name\":\"Бахмут\",\"value\":\"Бахмут\"},{\"name\":\"Бердичів\",\"value\":\"Бердичів\"},{\"name\":\"Бердянськ\",\"value\":\"Бердянськ\"},{\"name\":\"Березань\",\"value\":\"Березань\"},{\"name\":\"Бобровиця\",\"value\":\"Бобровиця\"},{\"name\":\"Богуслав\",\"value\":\"Богуслав\"},{\"name\":\"Бориспіль\",\"value\":\"Бориспіль\"},{\"name\":\"Бородянка\",\"value\":\"Бородянка\"},{\"name\":\"Бровари\",\"value\":\"Бровари\"},{\"name\":\"Біла Церква\",\"value\":\"Біла Церква\"},{\"name\":\"Білогородка\",\"value\":\"Білогородка\"},{\"name\":\"Васильків\",\"value\":\"Васильків\"},{\"name\":\"Вишгород\",\"value\":\"Вишгород\"},{\"name\":\"Вишневе\",\"value\":\"Вишневе\"},{\"name\":\"Ворзель\",\"value\":\"Ворзель\"},{\"name\":\"Вінниця\",\"value\":\"Вінниця\"},{\"name\":\"Віта-Поштова\",\"value\":\"Віта-Поштова\"},{\"name\":\"Гайсин\",\"value\":\"Гайсин\"},{\"name\":\"Гатне\",\"value\":\"Гатне\"},{\"name\":\"Глеваха\",\"value\":\"Глеваха\"},{\"name\":\"Гнідин\",\"value\":\"Гнідин\"},{\"name\":\"Гоголів\",\"value\":\"Гоголів\"},{\"name\":\"Гора\",\"value\":\"Гора\"},{\"name\":\"Городня\",\"value\":\"Городня\"},{\"name\":\"Гребінки\",\"value\":\"Гребінки\"},{\"name\":\"Дніпро\",\"value\":\"Дніпро\"},{\"name\":\"Дніпрорудне\",\"value\":\"Дніпрорудне\"},{\"name\":\"Дрогобич\",\"value\":\"Дрогобич\"},{\"name\":\"Дружківка\",\"value\":\"Дружківка\"},{\"name\":\"Жидачів\",\"value\":\"Жидачів\"},{\"name\":\"Житомир\",\"value\":\"Житомир\"},{\"name\":\"Зазим’я\",\"value\":\"Зазим’я\"},{\"name\":\"Запоріжжя\",\"value\":\"Запоріжжя\"},{\"name\":\"Калинівка\",\"value\":\"Калинівка\"},{\"name\":\"Калита\",\"value\":\"Калита\"},{\"name\":\"Кам'янець-Подільський\",\"value\":\"Кам'янець-Подільський\"},{\"name\":\"Кам'янське\",\"value\":\"Кам'янське\"},{\"name\":\"Київ\",\"value\":\"Київ\"},{\"name\":\"Княжичі\",\"value\":\"Княжичі\"},{\"name\":\"Козелець\",\"value\":\"Козелець\"},{\"name\":\"Козин\",\"value\":\"Козин\"},{\"name\":\"Костянтинівка\",\"value\":\"Костянтинівка\"},{\"name\":\"Коцюбинське\",\"value\":\"Коцюбинське\"},{\"name\":\"Кременчук\",\"value\":\"Кременчук\"},{\"name\":\"Кривий Ріг\",\"value\":\"Кривий Ріг\"},{\"name\":\"Кропивницький\",\"value\":\"Кропивницький\"},{\"name\":\"Крюківщина\",\"value\":\"Крюківщина\"},{\"name\":\"Куп'янськ\",\"value\":\"Куп'янськ\"},{\"name\":\"Ладижин\",\"value\":\"Ладижин\"},{\"name\":\"Лисичанськ\",\"value\":\"Лисичанськ\"},{\"name\":\"Лозова\",\"value\":\"Лозова\"},{\"name\":\"Луцьк\",\"value\":\"Луцьк\"},{\"name\":\"Львів\",\"value\":\"Львів\"},{\"name\":\"Лютіж\",\"value\":\"Лютіж\"},{\"name\":\"Ліски\",\"value\":\"Ліски\"},{\"name\":\"Маріуполь\",\"value\":\"Маріуполь\"},{\"name\":\"Мелітополь\",\"value\":\"Мелітополь\"},{\"name\":\"Миколаїв\",\"value\":\"Миколаїв\"},{\"name\":\"Миргород\",\"value\":\"Миргород\"},{\"name\":\"Миронівка\",\"value\":\"Миронівка\"},{\"name\":\"Новий Калинів\",\"value\":\"Новий Калинів\"},{\"name\":\"Новоград-Волинський\",\"value\":\"Новоград-Волинський\"},{\"name\":\"Новосілки\",\"value\":\"Новосілки\"},{\"name\":\"Нові Петрівці\",\"value\":\"Нові Петрівці\"},{\"name\":\"Ніжин\",\"value\":\"Ніжин\"},{\"name\":\"Овідіополь\",\"value\":\"Овідіополь\"},{\"name\":\"Одеса\",\"value\":\"Одеса\"},{\"name\":\"Остер\",\"value\":\"Остер\"},{\"name\":\"Павлоград\",\"value\":\"Павлоград\"},{\"name\":\"Петропавлівська Борщагівка\",\"value\":\"Петропавлівська Борщагівка\"},{\"name\":\"Погреби\",\"value\":\"Погреби\"},{\"name\":\"Полтава\",\"value\":\"Полтава\"},{\"name\":\"Прилуки\",\"value\":\"Прилуки\"},{\"name\":\"Проліски\",\"value\":\"Проліски\"},{\"name\":\"Рава-Руська\",\"value\":\"Рава-Руська\"},{\"name\":\"Рокитне\",\"value\":\"Рокитне\"},{\"name\":\"Рівне\",\"value\":\"Рівне\"},{\"name\":\"Самбір\",\"value\":\"Самбір\"},{\"name\":\"Святопетрівське\",\"value\":\"Святопетрівське\"},{\"name\":\"Славутич\",\"value\":\"Славутич\"},{\"name\":\"Сокаль\",\"value\":\"Сокаль\"},{\"name\":\"Софіївська Борщагівка\",\"value\":\"Софіївська Борщагівка\"},{\"name\":\"Ставище\",\"value\":\"Ставище\"},{\"name\":\"Старий Самбір\",\"value\":\"Старий Самбір\"},{\"name\":\"Старокостянтинів\",\"value\":\"Старокостянтинів\"},{\"name\":\"Стрий\",\"value\":\"Стрий\"},{\"name\":\"Сєвєродонецьк\",\"value\":\"Сєвєродонецьк\"},{\"name\":\"Тараща\",\"value\":\"Тараща\"},{\"name\":\"Теплодар\",\"value\":\"Теплодар\"},{\"name\":\"Тернопіль\",\"value\":\"Тернопіль\"},{\"name\":\"Трускавець\",\"value\":\"Трускавець\"},{\"name\":\"Тульчин\",\"value\":\"Тульчин\"},{\"name\":\"Ужгород\",\"value\":\"Ужгород\"},{\"name\":\"Узин\",\"value\":\"Узин\"},{\"name\":\"Фастів\",\"value\":\"Фастів\"},{\"name\":\"Харків\",\"value\":\"Харків\"},{\"name\":\"Херсон\",\"value\":\"Херсон\"},{\"name\":\"Хмельницький\",\"value\":\"Хмельницький\"},{\"name\":\"Хмільник\",\"value\":\"Хмільник\"},{\"name\":\"Хотянівка\",\"value\":\"Хотянівка\"},{\"name\":\"Христинівка\",\"value\":\"Христинівка\"},{\"name\":\"Червоноград\",\"value\":\"Червоноград\"},{\"name\":\"Черкаси\",\"value\":\"Черкаси\"},{\"name\":\"Чернівці\",\"value\":\"Чернівці\"},{\"name\":\"Чернігів\",\"value\":\"Чернігів\"},{\"name\":\"Чорноморськ\",\"value\":\"Чорноморськ\"},{\"name\":\"Чортків\",\"value\":\"Чортків\"},{\"name\":\"Щасливе\",\"value\":\"Щасливе\"},{\"name\":\"Южноукраїнськ\",\"value\":\"Южноукраїнськ\"},{\"name\":\"Яготин\",\"value\":\"Яготин\"}]");
            // console.log(cities[0])
        },
        watch: {
            clicked: function (v,o){
                if( this.show_list && !this.is_target ) {
                    this.show_list = false;
                }
                this.is_target = false;
            }
        }
    }
</script>

<style scoped>
    .label{
        display: block;
    }
</style>
